/*
 *  
 *  Copyright (c) 2004 Steve Slaven, All Rights Reserved.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA 02111-1307 USA
 *  
*/
package net.hoopajoo.cheeselab3;
import java.awt.*;
import java.awt.event.*;

import net.hoopajoo.swingx.*;

public class CheeseMapNavigator extends JEscDialog {
    private CheeseMapNavigatorCanvas canvas = null;

    CheeseMapNavigator( Frame owner ) {
        super( owner, false );
        setTitle( "Navigator" );
        addWindowListener(new WindowAdapter() {
                              public void windowClosing(WindowEvent e) {
                                  CheeseMap.navi_action.setSelected( false );
                              };
                          });

        Container cpane = getContentPane();
        canvas = new CheeseMapNavigatorCanvas();
        cpane.add( canvas );
        pack();


        /* Position us to the rightmost upper corner of our parent
               * window (or saved position).
               * FIXME: Check for out-of-screen or invalid position
         */

        setLocation(
            CheeseMap.prop_get_int( "navi_x",
                                    owner.getX() + owner.getWidth() - getWidth() ),
            CheeseMap.prop_get_int( "navi_y", owner.getY() ) );
    }

    public void save_ui_prefs() {
        Rectangle siz = getBounds();

        CheeseMap.props.setProperty( "navi_x", Integer.toString( siz.x ) );
        CheeseMap.props.setProperty( "navi_y", Integer.toString( siz.y ) );
        CheeseMap.props.setProperty( "navi_w", Integer.toString( canvas.getWidth() ) );
        CheeseMap.props.setProperty( "navi_h", Integer.toString( canvas.getHeight() ) );
    }
}
